Unit ZNUhr_EchtF;

Interface

Uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Grids, EStw06, Menus, ComCtrls, CheckLst,
  StellTi06, EStwV24, WSocket, WinSock, WSocketS, Schaltschrank06, DirLoop,
  PosPanel;

Const
  ZLVUSNrI=0;
  ZLVKurz='UHR';
  ZLVLang='Uhr';

Type
  TInternerClient=Class(TWSocketClient) // Server
                  Public
                    RcvdLine:String;
                    ConnectTime:TDateTime;
                    AuthCode:String;
                  End;

  TMainForm = class(TForm)
    SekundenTimer: TTimer;
    ConnectTimer: TTimer;
    ZLVBusClient: TWSocket;
    UDPZNServerSuche: TWSocket;
    Status: TStatusBar;
    UhrL: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure SendeZLVBusUhr(hh,mm,ss:Integer);
    procedure ConnectTimerTimer(Sender: TObject);
    procedure ZLVBusClientSessionConnected(Sender: TObject; Error: Word);
    procedure ZLVBusClientDataAvailable(Sender: TObject; Error: Word);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ZLVBusClientSessionClosed(Sender: TObject; Error: Word);
    procedure UDPZNServerSucheDataAvailable(Sender: TObject; Error: Word);
    procedure SekundenTimerTimer(Sender: TObject);
  private
    ComPort:Integer;

    ZLVBusClientAdr:String;
    ZLVBusClientPort:String;
    ZLVBusClientModus:Integer;
    ZLVBusUSNr:String;
    ZLVBusMHKompatibel:String;

    LastHH,LastMM,LastSS:Integer;

    Paket:Array[0..65536] of Char; // Eins zuviel! // ZLV-Client
    Anz:Integer;                                   // ZLV-Client

    InitScript:TStringlist;

    Procedure ProcessCommand(Paket:String); // ZLV-Client
    Procedure DoZLVConnect;
  public
    Function Connected:Boolean;                      // Client
  end;

Var
  MainForm:TMainForm;

Implementation

{$R *.DFM}

Function F2(z:Integer):String;
Begin
  Result:=IntToStr(z mod 100);
  If Length(Result)<2
  Then
    Result:='0'+Result;
End;


Procedure TMainForm.FormCreate(Sender: TObject);
Var
  i,p1,p2:Integer;
  s,n,h,ini,znm:String;

    Function GetString(n:String;Var r:String):Boolean;
    Var
      l:Integer;
    Begin
      l:=Length(n)+1;
      Result:=Pos(n+':',h)=1;
      If Result
      Then
        r:=Trim(Copy(h,l+1,Length(h)-l));
    End;

    Function GetInt(n:String;Var r:Integer):Boolean;
    Var
      s:String;
      j:Integer;
    Begin
      Result:=GetString(n,s);
      If Result
      Then
        Val(s,r,j);
    End;

Begin
  Left:=0;
  Top:=0;
  Anz:=0;

  ComPort:=0;
  ZLVBusClientAdr:='127.0.0.1';
  ZLVBusClientPort:='50099';
  ZLVBusClientModus:=2; // Neuer Defaultwert!
  ZLVBusUSNr:='';
  ZLVBusMHKompatibel:='';

  LastHH:=-1;
  LastMM:=-1;
  LastSS:=-1;

  InitScript:=TStringlist.Create;
  Try
    If FileExists(ParamStr(1)+'.ini')
    Then
      ini:=ParamStr(1)+'.ini'
    Else
      ini:='ZNUhr.ini';
    InitScript.LoadFromFile(ini);

    For i:=0 to InitScript.Count-1 do
    Begin
      s:=InitScript[i];
      p1:=Pos('<',s);
      p2:=Pos('>',s);
      If (p1=1) and (p2>2) and (Copy(s,1,2)<>'//')
      Then
      Begin
        n:=Trim(Copy(s,2,p2-2));
        h:=Trim(Copy(s,p2+1,Length(s)-p2));

        If n='ZLV-BUS'
        Then
        Begin
          GetString('SERVER',ZLVBusClientAdr);
          GetString('IPPORT',ZLVBusClientPort);
          GetString('MODUS',znm);
          If (znm='UDP')
          Then
            ZLVBusClientModus:=2
          Else If (znm='NEU')
          Then
            ZLVBusClientModus:=1
          Else If (znm='ALT')
          Then
            ZLVBusClientModus:=0;
          GetString('USNR',ZLVBusUSNr);
          GetString('MH_KOMPATIBEL',ZLVBusMHKompatibel);
        End;
      End;
    End;
  Except
  End;
End;

Procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
Begin
  InitScript.Free;
End;

Procedure TMainForm.SendeZLVBusUhr(hh,mm,ss:Integer);
Begin
  If Connected
  Then
  Begin
    If ZLVBusClientModus=0
    Then
      ZLVBusClient.SendStr('9991'+F2(hh)+':'+F2(mm)+':'+F2(ss)+'        ')
    Else
      ZLVBusClient.SendStr('UHR:'+F2(hh)+':'+F2(mm)+':'+F2(ss)+#13#10);
  End;
End;

Function TMainForm.Connected:Boolean;
Begin
  Result:=ZLVBusClient.State=wsConnected;
End;

Procedure TMainForm.ZLVBusClientSessionConnected(Sender: TObject;
  Error: Word);
Begin
  If Error<>0
  Then
    Status.Panels[0].Text:='ZLV-Bus-Connect-Fehler #'+IntToStr(Error)
  Else
    Status.Panels[0].Text:='ZLV-Bus ok!';
  Anz:=0;
End;

Procedure TMainForm.ZLVBusClientSessionClosed(Sender: TObject;
  Error: Word);
Begin
  Status.Panels[0].Text:='ZLV-Bus aus!';
End;

Procedure TMainForm.ProcessCommand(Paket:String);
    Procedure DoZLV(s:String);
    //Var
      //ust,typ,j:Integer;
      //zug,gleis:String;
    Begin
      //Val(Copy(Paket,1,2),ust,j);
      //Val(Copy(Paket,3,2),typ,j);
      //zug:=Trim(Copy(Paket,5,6));
      //gleis:=Trim(Copy(Paket,11,6));
      //VerarbeiteZNTelegramm(ust,typ,zug,gleis,'','',' ',' ')
    End;

Begin
  If ZLVBusClientModus=0
  Then
  Begin
    If Length(Paket)>=16
    Then
      DoZLV(Paket);
  End
  Else
  Begin // 1 und 2:
    If Copy(Paket,1,4)='ZLV:'
    Then
    Begin
      Paket:=Copy(Paket,5,Length(Paket)-4);
      If Length(Paket)>=16
      Then
        DoZLV(Paket);
    End; //### Andere Pakete?
  End;
End;

Procedure TMainForm.ZLVBusClientDataAvailable(Sender: TObject; Error: Word);
Var
  i,j:Integer;
  s,z:String;
Begin
  z:=ZLVBusClient.ReceiveStr;
  For i:=1 to Length(z) do
  Begin
    If z[i] in [#13,#10]
    Then
    Begin // Zeilentrenner:
      If Anz>0
      Then
      Begin
        s:='';
        For j:=0 to Anz-1 do
          s:=s+Paket[j];
        ProcessCommand(s);
        Anz:=0;
      End;
    End
    Else If z[i]>=#32
    Then
    Begin // Inhalt...
      If Anz<256
      Then
      Begin
        Paket[Anz]:=z[i];
        Inc(Anz);
      End;
    End;
  End;
End;

Procedure TMainForm.DoZLVConnect;
    Function Norm(nr:Integer;l:Integer):String;Overload;
    Begin
      Result:=Copy(IntToStr(nr),1,l);
      If l>Length(Result)
      Then
        Result:=StringOfChar('0',l-Length(Result))+Result;
    End;

    Function Norm(s:String;l:Integer):String;Overload;
    Begin
      Result:=Copy(s,1,l);
      If l>Length(Result)
      Then
        Result:=Result+StringOfChar(' ',l-Length(Result));
    End;
Begin
  If not Connected
  Then
  Begin
    ZLVBusClient.Addr:=ZLVBusClientAdr;
    ZLVBusClient.Port:=ZLVBusClientPort;
    ZLVBusClient.Proto:='tcp';
    ZLVBusClient.Connect;
    // Connect is asynchronous (non-blocking). We will wait while the
    // session is connecting or application terminated.
    While ZLVBusClient.State in [wsConnecting] do
    Begin
      Application.ProcessMessages;
      If Application.Terminated
      Then
        Exit;
    End;

    If Connected
    Then
    Begin
      If ZLVBusClientModus=0
      Then
        ZLVBusClient.SendStr(Norm(ZLVUSNrI,2)+'92'+'01'+Norm(ZLVKurz,14))//+#13+#10)
      Else // 1 und 2
        ZLVBusClient.SendStr('ID:'+ZLVKurz+','+ZLVLang+#13#10);
      //VerarbeiteZNTelegramm(-1,-1,'','','','',' ',' ');
    End;
  End;
End;

Procedure TMainForm.UDPZNServerSucheDataAvailable(Sender: TObject; Error: Word);
Var
  Buffer:Array[0..2047] of Char;
  Len,p,port,j:Integer;
  Src:TSockAddrIn;
  SrcLen:Integer;
  s:String;
Begin
  SrcLen:=SizeOf(Src);
  Try // UDPZNServerSuche=(Sender as TWSocket)!!!
    Len:=UDPZNServerSuche.ReceiveFrom(@Buffer,SizeOf(Buffer)-1,Src,SrcLen);
    If Len>=0
    Then
    Begin
      Buffer[Len]:=#0;
      s:=StrPas(Buffer);

      //DoProto(StrPas(inet_ntoa(Src.sin_addr))+':'+IntToStr(ntohs(Src.sin_port))+'--> '+s);

      p:=Pos('ZNSERVERPORT:',s);
      If p=1
      Then
      Begin
        Val(Copy(s,14,Length(s)-13),port,j);
        ZLVBusClientAdr:=StrPas(inet_ntoa(Src.sin_addr));
        ZLVBusClientPort:=IntToStr(port);//ntohs(Src.sin_port));
        DoZLVConnect;
      End;
    End;
  Except
  End;
End;

Procedure TMainForm.ConnectTimerTimer(Sender: TObject);
Begin
  ConnectTimer.Enabled:=False;
  If (not Connected) and (Trim(ZLVBusClientAdr)<>'')
  Then
  Begin
    If ZLVBusClientModus=2
    Then
    Begin
      UDPZNServerSuche.Addr:='255.255.255.255';
      UDPZNServerSuche.Port:='57111';
      UDPZNServerSuche.Proto:='udp';
      If UDPZNServerSuche.State=wsClosed
      Then
        UDPZNServerSuche.Connect;
      UDPZNServerSuche.SendStr('ZNSERVER?');
    End
    Else // 0 oder 1:
      DoZLVConnect;
  End;
  ConnectTimer.Enabled:=True;
End;

Procedure TMainForm.SekundenTimerTimer(Sender: TObject);
Var
  h,m,s,ms:Word;
Begin
  DecodeTime(Now,h,m,s,ms);
  If (h<>LastHH) or (m<>LastMM) or (s<>LastSS)
  Then
  Begin
    SendeZLVBusUhr(h,m,s);
    LastHH:=h;
    LastMM:=m;
    LastSS:=s;
    UhrL.Caption:=F2(h)+':'+F2(m)+':'+F2(s);
  End;
End;

End.

